## gerbera-dmo 3.1.1

=== CMakeLists.txt ===
#*GRB*
#
#  Gerbera - https://gerbera.io/
#
#  CMakeLists.txt - this file is part of Gerbera.
#
#  Copyright (C) 2016-2026 Gerbera Contributors
#
#  Gerbera is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation.
#
#  Gerbera is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Gerbera.  If not, see <http://www.gnu.org/licenses/>.
#
#  $Id$

cmake_minimum_required(VERSION 3.19 FATAL_ERROR)
cmake_policy(VERSION 3.13)

# Only set for release tags
# You should only see version "git" when built from a git snapshot tarball
set(GERBERA_VERSION "3.1.1")

project(Gerbera
        DESCRIPTION "UPnP Media Server"
        HOMEPAGE_URL "https://gerbera.io"
        LANGUAGES CXX C)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

# If Conan stuff is present, load it
include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake OPTIONAL)
if(COMMAND conan_basic_setup)
    # Prefer the conan FindModules
    list(PREPEND CMAKE_MODULE_PATH ${CMAKE_BINARY_DIR})
    conan_basic_setup(TARGETS)
endif()

# set(CMAKE_INSTALL_PREFIX /usr/local)
set(CMAKE_INSTALL_BINDIR bin)
set(CMAKE_INSTALL_DATADIR share/gerbera)
set(CMAKE_INSTALL_MANDIR share/man/man1)

option(WITH_NPUPNP            "Use npupnp instead of libupnp" OFF)
option(WITH_MAGIC             "Use libmagic to identify file mime types" ON)
option(WITH_MYSQL             "Store media information in MySQL DB" OFF)
option(WITH_PGSQL             "Store media information in PostgreSQL DB" OFF)
option(WITH_CURL              "CURL required for online services" ON)
option(WITH_INOTIFY           "Enable Inotify file monitoring support" ON)
option(WITH_JS                "Enable JavaScript for scripting" ON)
option(WITH_TAGLIB            "Use TagLib to extract audio file metadata" ON)
option(WITH_AVCODEC           "Use ffmpeg/libav to extract file metadata" OFF)
option(WITH_WAVPACK           "Use wavpack to extract audio file metadata" OFF)
option(WITH_FFMPEGTHUMBNAILER "Enable Thumbnail generation" OFF)
option(WITH_EXIF              "Use libexif to extract image metadata" ON)
option(WITH_EXIV2             "Use libexiv2 to extract image metadata" ON)
option(WITH_MATROSKA          "Use libmatroska to extract video/mkv metadata" ON)
option(WITH_SYSTEMD           "Install Systemd unit file and notify systemd" ON)
option(WITH_LASTFM            "Enable scrobbling to LastFM" OFF)
option(WITH_ICU               "Enable Support for transliteration" ON)
option(WITH_ZIP               "Enable zip for package download" ON)
option(WITH_ONLINE_SERVICES   "Enable support for Online Services" OFF) # currently there is no online service left, this enables compiling the empty shell
option(WITH_DEBUG             "Enables debug logging" ON)
option(WITH_DEBUG_OPTIONS     "Enables dedicated debug messages" ON)
option(WITH_TESTS             "Build unit tests" OFF)

option(INSTALL_DOC            "Install generated documentation into target" OFF)
option(BUILD_DOC              "Add 'doc' target to generate source documentation" OFF)
option(BUILD_CHANGELOG        "Build 'changelog.gz' file for Debian packages" OFF)

# For building packages without depending on the old system libupnp
option(STATIC_LIBUPNP         "Link to libupnp statically" OFF)

# Leverage a modern C++
# Set defaults here before we create targets
set(CMAKE_CXX_STANDARD 17)
# Cygwin requires extensions for a lot of the networking stuff.
if(CYGWIN)
    set(CMAKE_CXX_STANDARD_REQUIRED NO)
    set(CMAKE_CXX_EXTENSIONS YES)
else(CYGWIN)
    set(CMAKE_CXX_STANDARD_REQUIRED YES)
    set(CMAKE_CXX_EXTENSIONS NO)
endif(CYGWIN)

add_library(libgerbera STATIC
        src/action_request.cc
        src/action_request.h
        src/cds/cds_container.cc
        src/cds/cds_container.h
        src/cds/cds_enums.cc
        src/cds/cds_enums.h
        src/cds/cds_item.cc
        src/cds/cds_item.h
        src/cds/cds_objects.cc
        src/cds/cds_objects.h
        src/cds/cds_resource.cc
        src/cds/cds_resource.h
        src/common.h
        src/config/config_definition.cc
        src/config/config_definition.h
        src/config/config_generator.cc
        src/config/config_generator.h
        src/config/config_int_types.h
        src/config/config_manager.cc
        src/config/config_manager.h
        src/config/config_option_enum.h
        src/config/config_options.cc
        src/config/config_options.h
        src/config/config_setup.cc
        src/config/config_setup.h
        src/config/config_val.h
        src/config/grb_compile_info.cc
        src/config/grb_runtime.cc
        src/config/grb_runtime.h
        src/config/result/autoscan.cc
        src/config/result/autoscan.h
        src/config/result/box_layout.cc
        src/config/result/box_layout.h
        src/config/result/client_config.cc
        src/config/result/client_config.h
        src/config/result/directory_tweak.cc
        src/config/result/directory_tweak.h
        src/config/result/dynamic_content.cc
        src/config/result/dynamic_content.h
        src/config/result/edit_helper.h
        src/config/result/transcoding.cc
        src/config/result/transcoding.h
        src/config/setup/config_setup_array.cc
        src/config/setup/config_setup_array.h
        src/config/setup/config_setup_autoscan.cc
        src/config/setup/config_setup_autoscan.h
        src/config/setup/config_setup_bool.cc
        src/config/setup/config_setup_bool.h
        src/config/setup/config_setup_boxlayout.cc
        src/config/setup/config_setup_boxlayout.h
        src/config/setup/config_setup_client.cc
        src/config/setup/config_setup_client.h
        src/config/setup/config_setup_dictionary.cc
        src/config/setup/config_setup_dynamic.cc
        src/config/setup/config_setup_dynamic.h
        src/config/setup/config_setup_enum.h
        src/config/setup/config_setup_int.cc
        src/config/setup/config_setup_int.h
        src/config/setup/config_setup_path.cc
        src/config/setup/config_setup_path.h
        src/config/setup/config_setup_string.cc
        src/config/setup/config_setup_string.h
        src/config/setup/config_setup_time.cc
        src/config/setup/config_setup_time.h
        src/config/setup/config_setup_transcoding.cc
        src/config/setup/config_setup_transcoding.h
        src/config/setup/config_setup_tweak.cc
        src/config/setup/config_setup_tweak.h
        src/config/setup/config_setup_vector.cc
        src/config/setup/config_setup_vector.h
        src/config/setup/setup_util.h
        src/content/autoscan_list.cc
        src/content/autoscan_list.h
        src/content/autoscan_setting.cc
        src/content/autoscan_setting.h
        src/content/cm_task.cc
        src/content/cm_task.h
        src/content/content.h
        src/content/content_manager.cc
        src/content/content_manager.h
        src/content/import_service.cc
        src/content/import_service.h
        src/content/inotify/autoscan_inotify.cc
        src/content/inotify/autoscan_inotify.h
        src/content/inotify/directory_watch.cc
        src/content/inotify/directory_watch.h
        src/content/inotify/inotify_handler.cc
        src/content/inotify/inotify_handler.h
        src/content/inotify/inotify_manager_cc.h
        src/content/inotify/inotify_manager.h
        src/content/inotify/inotify_types.cc
        src/content/inotify/inotify_types.h
        src/content/inotify/mt_inotify.cc
        src/content/inotify/mt_inotify.h
        src/content/inotify/scripting_inotify.cc
        src/content/inotify/scripting_inotify.h
        src/content/inotify/watch.h
        src/content/layout/builtin_layout.cc
        src/content/layout/builtin_layout.h
        src/content/layout/js_layout.cc
        src/content/layout/js_layout.h
        src/content/layout/layout.cc
        src/content/layout/layout.h
        src/content/onlineservice/curl_online_service.cc
        src/content/onlineservice/curl_online_service.h
        src/content/onlineservice/lastfm_scrobbler.cc
        src/content/onlineservice/lastfm_scrobbler.h
        src/content/onlineservice/lastfmlib.cc
        src/content/onlineservice/lastfmlib.h
        src/content/onlineservice/online_service.cc
        src/content/onlineservice/online_service.h
        src/content/onlineservice/online_service_helper.cc
        src/content/onlineservice/online_service_helper.h
        src/content/onlineservice/task_processor.cc
        src/content/onlineservice/task_processor.h
        src/content/scripting/duk_compat.h
        src/content/scripting/import_script.cc
        src/content/scripting/import_script.h
        src/content/scripting/js_functions.cc
        src/content/scripting/js_functions.h
        src/content/scripting/metafile_parser_script.cc
        src/content/scripting/metafile_parser_script.h
        src/content/scripting/parser_script.cc
        src/content/scripting/parser_script.h
        src/content/scripting/playlist_parser_script.cc
        src/content/scripting/playlist_parser_script.h
        src/content/scripting/script.cc
        src/content/scripting/script.h
        src/content/scripting/script_names.h
        src/content/scripting/script_property.cc
        src/content/scripting/script_property.h
        src/content/scripting/scripting_runtime.cc
        src/content/scripting/scripting_runtime.h
        src/content/update_manager.cc
        src/content/update_manager.h
        src/context.cc
        src/context.h
        src/contrib/md5.c
        src/contrib/md5.h
        src/database/database.cc
        src/database/database.h
        src/database/db_param.h
        src/database/mysql/mysql_database.cc
        src/database/mysql/mysql_database.h
        src/database/mysql/mysql_result.cc
        src/database/mysql/mysql_result.h
        src/database/postgres/postgres_database.cc
        src/database/postgres/postgres_database.h
        src/database/postgres/pg_result.cc
        src/database/postgres/pg_result.h
        src/database/postgres/pg_task.cc
        src/database/postgres/pg_task.h
        src/database/search_handler.cc
        src/database/search_handler.h
        src/database/sql_database.cc
        src/database/sql_database.h
        src/database/sql_format.h
        src/database/sql_result.h
        src/database/sql_table.cc
        src/database/sql_table.h
        src/database/sqlite3/sl_result.cc
        src/database/sqlite3/sl_result.h
        src/database/sqlite3/sl_task.cc
        src/database/sqlite3/sl_task.h
        src/database/sqlite3/sqlite_config.cc
        src/database/sqlite3/sqlite_config.h
        src/database/sqlite3/sqlite_database.cc
        src/database/sqlite3/sqlite_database.h
        src/exceptions.cc
        src/exceptions.h
        src/iohandler/buffered_io_handler.cc
        src/iohandler/buffered_io_handler.h
        src/iohandler/curl_io_handler.cc
        src/iohandler/curl_io_handler.h
        src/iohandler/file_io_handler.cc
        src/iohandler/file_io_handler.h
        src/iohandler/io_handler.cc
        src/iohandler/io_handler.h
        src/iohandler/io_handler_buffer_helper.cc
        src/iohandler/io_handler_buffer_helper.h
        src/iohandler/io_handler_chainer.cc
        src/iohandler/io_handler_chainer.h
        src/iohandler/mem_io_handler.cc
        src/iohandler/mem_io_handler.h
        src/iohandler/process_io_handler.cc
        src/iohandler/process_io_handler.h
        src/metadata/exiv2_handler.cc
        src/metadata/exiv2_handler.h
        src/metadata/ffmpeg_handler.cc
        src/metadata/ffmpeg_handler.h
        src/metadata/ffmpeg_thumbnailer_handler.cc
        src/metadata/ffmpeg_thumbnailer_handler.h

=== doc/requirements.txt ===
sphinx==8.2.3
sphinx-rtd-theme==3.0.2
sphinx-rtd-dark-mode==1.3.0
sphinx_toolbox
snowballstemmer<3.0

=== test/CMakeLists.txt ===
#*GRB*
#
#  Gerbera - https://gerbera.io/
#
#  CMakeLists.txt - this file is part of Gerbera.
#
#  Copyright (C) 2016-2026 Gerbera Contributors
#
#  Gerbera is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation.
#
#  Gerbera is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Gerbera.  If not, see <http://www.gnu.org/licenses/>.
#
#  $Id$

find_package(GTest REQUIRED)

# CMake can't fix gmock support. https://gitlab.kitware.com/cmake/cmake/-/issues/17365
# So for non-conan build we need to find it separately.
if (NOT "${GTest_LIBRARY_LIST}" MATCHES "gmock")
    if (NOT TARGET GTest::gmock)
        message ("No GMock in GTest")
        find_package(GMock REQUIRED)
        set_property(TARGET GTest::GTest APPEND PROPERTY INTERFACE_LINK_LIBRARIES ${GMOCK_LIBRARIES})
    endif()
endif()

## Add tests below
add_subdirectory(config)
add_subdirectory(content)
add_subdirectory(core)
if(WITH_JS)
    add_subdirectory(scripting)
endif()
add_subdirectory(database)
add_subdirectory(util)

=== test/config/CMakeLists.txt ===
#*GRB*
#
#  Gerbera - https://gerbera.io/
#
#  CMakeLists.txt - this file is part of Gerbera.
#
#  Copyright (C) 2016-2026 Gerbera Contributors
#
#  Gerbera is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation.
#
#  Gerbera is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Gerbera.  If not, see <http://www.gnu.org/licenses/>.
#
#  $Id$

add_executable(testconfig
    main.cc
    test_configgenerator.cc
    test_configmanager.cc
)

if (NOT TARGET GTest::gmock)
    target_link_libraries(testconfig PRIVATE
        libgerbera
        GTest::GTest
    )
else()
    target_link_libraries(testconfig PRIVATE
        libgerbera
        GTest::gmock
    )
endif()

target_compile_definitions(testconfig PRIVATE CMAKE_BINARY_DIR="${CMAKE_BINARY_DIR}")
target_compile_definitions(testconfig PRIVATE GERBERA_TEST="gerbera-test")

add_dependencies(testconfig libgerbera gerbera)

include(GoogleTest)

gtest_discover_tests(testconfig DISCOVERY_TIMEOUT 60 TEST_LIST GRB_CONFIG_TESTS)

add_test(NAME configFixtures
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/fixtures ${CMAKE_CURRENT_BINARY_DIR}/fixtures
    # DEPENDS fixtures/*
)
set_tests_properties(configFixtures PROPERTIES FIXTURES_SETUP GrbConfig)

set_property(DIRECTORY APPEND PROPERTY
    TEST_INCLUDE_FILES ${CMAKE_CURRENT_LIST_DIR}/CTestManip.cmake
)

=== test/content/CMakeLists.txt ===
#*GRB*
#
#  Gerbera - https://gerbera.io/
#
#  CMakeLists.txt - this file is part of Gerbera.
#
#  Copyright (C) 2016-2026 Gerbera Contributors
#
#  Gerbera is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation.
#
#  Gerbera is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Gerbera.  If not, see <http://www.gnu.org/licenses/>.
#
#  $Id$

add_executable(testcontent
    main.cc
    test_autoscan_list.cc
    test_resolution.cc
)

if (NOT TARGET GTest::gmock)
    target_link_libraries(testcontent PRIVATE
        libgerbera
        GTest::GTest
    )
else()
    target_link_libraries(testcontent PRIVATE
        libgerbera
        GTest::gmock
    )
endif()
add_dependencies(testcontent libgerbera gerbera)

include(GoogleTest)
gtest_discover_tests(testcontent DISCOVERY_TIMEOUT 60)

=== test/core/CMakeLists.txt ===
#*GRB*
#
#  Gerbera - https://gerbera.io/
#
#  CMakeLists.txt - this file is part of Gerbera.
#
#  Copyright (C) 2016-2026 Gerbera Contributors
#
#  Gerbera is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation.
#
#  Gerbera is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Gerbera.  If not, see <http://www.gnu.org/licenses/>.
#
#  $Id$

include(GoogleTest)
generate_compile_info()

add_executable(testcore
    main.cc
    test_searchhandler.cc
    test_server.cc
    test_upnp_map.cc
    test_upnp_xml.cc
    test_ffmpeg_cache_paths.cc
    test_url_utils.cc
)

if (NOT TARGET GTest::gmock)
    target_link_libraries(testcore PRIVATE
        libgerbera
        GTest::GTest
    )
else()
    target_link_libraries(testcore PRIVATE
        libgerbera
        GTest::gmock
    )
endif()

target_compile_definitions(testcore PRIVATE CMAKE_BINARY_DIR="$<TARGET_FILE_DIR:gerbera>")
target_compile_definitions(testcore PRIVATE COMPILE_INFO="${COMPILE_INFO}")
target_compile_definitions(testcore PRIVATE GIT_BRANCH="${GIT_BRANCH}")
target_compile_definitions(testcore PRIVATE GIT_COMMIT_HASH="${GIT_COMMIT_HASH}")
add_dependencies(testcore libgerbera gerbera)

gtest_discover_tests(testcore DISCOVERY_TIMEOUT 60 TEST_LIST GRB_CORE_TESTS)

add_test(NAME coreFixtures
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/fixtures ${CMAKE_CURRENT_BINARY_DIR}/fixtures
    # DEPENDS fixtures/*
)
set_tests_properties(coreFixtures PROPERTIES FIXTURES_SETUP GrbCore)

set_property(DIRECTORY APPEND PROPERTY
    TEST_INCLUDE_FILES ${CMAKE_CURRENT_LIST_DIR}/CTestManip.cmake
)

=== test/database/CMakeLists.txt ===
#*GRB*
#
#  Gerbera - https://gerbera.io/
#
#  CMakeLists.txt - this file is part of Gerbera.
#
#  Copyright (C) 2016-2026 Gerbera Contributors
#
#  Gerbera is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation.
#
#  Gerbera is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Gerbera.  If not, see <http://www.gnu.org/licenses/>.
#
#  $Id$

add_executable(testdb
    main.cc
    test_database.cc
    test_sql_generators.cc
    postgres_config_fake.h
    mysql_config_fake.h
    sqlite_config_fake.h)

if (NOT TARGET GTest::gmock)
    target_link_libraries(testdb PRIVATE
        libgerbera
        GTest::GTest
    )
else()
    target_link_libraries(testdb PRIVATE
        libgerbera
        GTest::gmock
    )
endif()
add_dependencies(testdb libgerbera gerbera)

include(GoogleTest)
gtest_discover_tests(testdb DISCOVERY_TIMEOUT 60 TEST_LIST GRB_DB_TESTS)

add_test(NAME dbFixturesSqLite
    COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/src/database/sqlite3/sqlite3.sql ${CMAKE_CURRENT_BINARY_DIR}
    # DEPENDS fixtures/*
)
add_test(NAME dbFixturesSqLiteDrop
    COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/src/database/sqlite3/sqlite3-drop.sql ${CMAKE_CURRENT_BINARY_DIR}
    # DEPENDS fixtures/*
)
add_test(NAME dbFixturesSqliteUpgrade
    COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/src/database/sqlite3/sqlite3-upgrade.xml ${CMAKE_CURRENT_BINARY_DIR}
    # DEPENDS fixtures/*
)
add_test(NAME dbFixturesMySql
    COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/src/database/mysql/mysql.sql ${CMAKE_CURRENT_BINARY_DIR}
    # DEPENDS fixtures/*
)
add_test(NAME dbFixturesMySqlDrop
    COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/src/database/mysql/mysql-drop.sql ${CMAKE_CURRENT_BINARY_DIR}
    # DEPENDS fixtures/*
)
add_test(NAME dbFixtureMySqlUpgrade
    COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/src/database/mysql/mysql-upgrade.xml ${CMAKE_CURRENT_BINARY_DIR}
    # DEPENDS fixtures/*
)
add_test(NAME dbFixturesPostgres
    COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/src/database/postgres/postgres.sql ${CMAKE_CURRENT_BINARY_DIR}
    # DEPENDS fixtures/*
)
add_test(NAME dbFixturesPostgresDrop
    COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/src/database/postgres/postgres-drop.sql ${CMAKE_CURRENT_BINARY_DIR}
    # DEPENDS fixtures/*
)
add_test(NAME dbFixturePostgresUpgrade
    COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/src/database/postgres/postgres-upgrade.xml ${CMAKE_CURRENT_BINARY_DIR}
    # DEPENDS fixtures/*
)
set_tests_properties(
    dbFixturesSqLite dbFixturesSqliteUpgrade dbFixturesSqLiteDrop
    dbFixturesMySql dbFixtureMySqlUpgrade dbFixturesMySqlDrop
    dbFixturesPostgres dbFixturePostgresUpgrade dbFixturesPostgresDrop
    PROPERTIES FIXTURES_SETUP GrbDb)

set_property(DIRECTORY APPEND PROPERTY
    TEST_INCLUDE_FILES ${CMAKE_CURRENT_LIST_DIR}/CTestManip.cmake
)

=== test/scripting/CMakeLists.txt ===
#*GRB*
#
#  Gerbera - https://gerbera.io/
#
#  CMakeLists.txt - this file is part of Gerbera.
#
#  Copyright (C) 2016-2026 Gerbera Contributors
#
#  Gerbera is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation.
#
#  Gerbera is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Gerbera.  If not, see <http://www.gnu.org/licenses/>.
#
#  $Id$

add_executable(testscripting
    main.cc
    mock/common_script_mock.h
    mock/duk_helper.cc
    mock/duk_helper.h
    mock/script_test_fixture.cc
    mock/script_test_fixture.h
    test_common_script.cc
    test_external_asx_playlist.cc
    test_external_m3u_playlist.cc
    test_external_pls_playlist.cc
    test_import_community_scripts.cc
    test_import_details_script.cc
    test_import_initials_script.cc
    test_import_script.cc
    test_import_struct_script.cc
    test_internal_m3u8_playlist.cc
    test_internal_m3u_playlist.cc
    test_internal_pls_playlist.cc
    test_nfo_metafile.cc
    test_runtime.cc
)

if (NOT TARGET GTest::gmock)
    target_link_libraries(testscripting PRIVATE
        libgerbera
        GTest::GTest
    )
else()
    target_link_libraries(testscripting PRIVATE
        libgerbera
        GTest::gmock
    )
endif()

target_compile_definitions(testscripting PRIVATE SCRIPTS_DIR="${CMAKE_SOURCE_DIR}/scripts")
add_dependencies(testscripting libgerbera gerbera)

include(GoogleTest)
gtest_discover_tests(testscripting DISCOVERY_TIMEOUT 60 TEST_LIST GRB_SCRIPTING_TESTS)

add_test(NAME scriptingFixtures
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/fixtures ${CMAKE_CURRENT_BINARY_DIR}/fixtures
    # DEPENDS fixtures/*
)
set_tests_properties(scriptingFixtures PROPERTIES FIXTURES_SETUP GrbScripting)

set_property(DIRECTORY APPEND PROPERTY
    TEST_INCLUDE_FILES ${CMAKE_CURRENT_LIST_DIR}/CTestManip.cmake
)

=== test/util/CMakeLists.txt ===
#*GRB*
#
#  Gerbera - https://gerbera.io/
#
#  CMakeLists.txt - this file is part of Gerbera.
#
#  Copyright (C) 2016-2026 Gerbera Contributors
#
#  Gerbera is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License version 2
#  as published by the Free Software Foundation.
#
#  Gerbera is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with Gerbera.  If not, see <http://www.gnu.org/licenses/>.
#
#  $Id$

add_executable(testutil
    main.cc
    test_tools.cc
    test_upnp_clients.cc
    test_upnp_headers.cc
    test_jpeg_res.cc
)

if (NOT TARGET GTest::gmock)
    target_link_libraries(testutil PRIVATE
        libgerbera
        GTest::GTest
    )
else()
    target_link_libraries(testutil PRIVATE
        libgerbera
        GTest::gmock
    )
endif()

add_dependencies(testutil libgerbera gerbera)

include(GoogleTest)
gtest_discover_tests(testutil DISCOVERY_TIMEOUT 60 TEST_LIST GRB_UTIL_TESTS)

add_test(NAME utilFixtures
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/testdata ${CMAKE_CURRENT_BINARY_DIR}/testdata
    # DEPENDS testdata/*
)
set_tests_properties(utilFixtures PROPERTIES FIXTURES_SETUP GrbUtil)

set_property(DIRECTORY APPEND PROPERTY
    TEST_INCLUDE_FILES ${CMAKE_CURRENT_LIST_DIR}/CTestManip.cmake
)

=== debian/changelog ===
gerbera-dmo (1:3.1.1-dmo3) unstable; urgency=medium

  * Build with libicu78

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 02 Mar 2026 07:26:40 +0100

gerbera-dmo (1:3.1.1-dmo2) unstable; urgency=medium

  * Build with libupnp20

 -- Christian Marillat <marillat@deb-multimedia.org>  Tue, 10 Feb 2026 17:16:17 +0100

gerbera-dmo (1:3.1.1-dmo1) unstable; urgency=medium

  * New upstream release.

 -- Christian Marillat <marillat@deb-multimedia.org>  Mon, 19 Jan 2026 08:22:47 +0100

=== debian/control ===
Source: gerbera-dmo
Section: net
Maintainer: Christian Marillat <marillat@deb-multimedia.org>
Bugs: mailto:marillat@deb-multimedia.org
Homepage: https://gerbera.io/
Standards-Version: 4.7.3
Build-Depends-Indep: python3-sphinx-rtd-theme, dh-sequence-sphinxdoc,
 python3-sphinx-toolbox,
Build-Depends: debhelper-compat (= 13), cmake, uuid-dev, libupnp-dev (>= 2:1.18~),
 duktape-dev (>= 2.7.0), libexif-dev, libexpat-dev, libsqlite3-dev, systemd-dev,
 libtag-dev, libcurl4-openssl-dev, libmagic-dev, libz-dev, pkgconf, libsystemd-dev,
 libexiv2-dev (>= 0.27), libfmt-dev (>= 9.1~), libspdlog-dev (>= 1:1.15.0~),
 libffmpegthumbnailer-dev (>= 1:2.3.0~), libpugixml-dev (>= 1.14~),
 libmatroska-dev (>= 1:1.6.0), default-libmysqlclient-dev (>= 1.0.5),
 libjs-popper.js, ninja-build, libavutil-dev, libavformat-dev, libavcodec-dev,
 libjsoncpp-dev, libicu-dev, 
 dh-linktree,
 libjs-jquery-ui, libjs-jquery, fonts-font-awesome,

## libjs-bootstrap4,

Package: gerbera
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: ${shlibs:Depends}, adduser, sysvinit-utils (>= 3.05-4~), ${misc:Depends},
Description: UPnP MediaServer
 Gerbera is an UPnP MediaServer with a nice web user interface based on
 MediaTomb. It allows you to stream your digital media through your home
 network and listen to/watch it on a variety of UPnP compatible devices.
 .
 Gerbera implements the UPnP MediaServer V 1.0 specification that can be
 found on https://www.upnp.org/. The current implementation focuses on parts
 that are required by the specification, however Gerbera's functionality is
 extended to cover the optional parts of the spec as well.

Package: gerbera-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends},
Description: UPnP MediaServer - documentation
 Gerbera is an UPnP MediaServer with a nice web user interface based on
 MediaTomb. It allows you to stream your digital media through your home
 network and listen to/watch it on a variety of UPnP compatible devices.
 .
 Gerbera implements the UPnP MediaServer V 1.0 specification that can be
 found on https://www.upnp.org/. The current implementation focuses on parts
 that are required by the specification, however Gerbera's functionality is
 extended to cover the optional parts of the spec as well.
 .
 This package contains the documentation for Gerbera.

=== debian/rules ===
#!/usr/bin/make -f

# needded by sphinx-build
export HOME := $(CURDIR)/debian/HOME

%:
	dh $@ -Scmake+ninja --with linktree,sphinxdoc

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DBUILD_DOC=OFF \
	-DINSTALL_DOC=OFF \
	-DWITH_AVCODEC=ON \
	-DWITH_EXIV2=ON \
	-DWITH_FFMPEGTHUMBNAILER=ON \
	-DWITH_JS=ON \
	-DWITH_MYSQL=ON \
	-DWITH_NPUPNP=OFF \
	-DWITH_PUPNP=ON \
	-DWITH_TAGLIB=ON \
	-DWITH_ZIP=OFF

#	exit 1

override_dh_auto_build-indep:
	cd doc && sphinx-build -b html ./ _build/html

override_dh_auto_test:
